using System;
using System.Reflection;

// this helper class uses reflection to simplify
// running batch tests against the Validate class
public class Test {
    public static void Good(string userInput, string validateMethod) {
        runTest(true, userInput, validateMethod);
    }
    public static void Bad(string userInput, string validateMethod) {
        runTest(false, userInput, validateMethod);
    }

    static void runTest(bool userInputIsGood, string userInput, string validateMethod) {
        MethodInfo mi = typeof(Validate).GetMethod(validateMethod, BindingFlags.Public | BindingFlags.Static);
        bool studentThinksInputIsGood = false;
        try {
            mi.Invoke(null, new object[] { userInput });
            studentThinksInputIsGood = true;
        }
        catch (TargetInvocationException x) {
            if (typeof(ValidationException) != x.InnerException.GetType()) throw x.InnerException;
        }
        if (studentThinksInputIsGood && !userInputIsGood) {
            Console.WriteLine("FALSE POSITIVE: {0} is malformed, but {1} said it was OK.", userInput, validateMethod);
        }
        else if (!studentThinksInputIsGood && userInputIsGood) {
            Console.WriteLine("FALSE NEGATIVE: {0} is valid, but {1} said it was malformed.", userInput, validateMethod);
        }
    }
}